uniform sampler2D uTexUnit;

struct Material {
    vec3 aColor;
    vec3 dColor;
    vec3 sColor;
    float shine;
};
uniform int uHasATexture;
varying vec2 vTexCoord;

uniform Material uMat;
varying vec3 vColor;

uniform vec3 uLColor;
uniform vec3 uLightPos;

varying vec3 vView;
varying vec3 vNormal;
varying vec3 vLight;
varying vec3 vReflection;

void main()
{
    if (uHasATexture == 0)
    {
        vec4 ambient = vec4(uMat.aColor * uLColor, 1.0);
        vec4 diffuse = vec4(uMat.dColor * uLColor * max(dot(vNormal, vLight), 0.0), 1.0);
        vec4 specular = vec4(
                             uMat.sColor *
                             uLColor *
                             pow(max(dot(vReflection, vView), 0.0),
                                 uMat.shine
                                 ),
                             1);
        
        gl_FragColor = ambient + diffuse + specular;
    }
    else
    {

        //vec4 texColor0 = vec4(vColor.x, vColor.y, vColor.z, 1);
        vec4 texColor1 = texture2D(uTexUnit, vTexCoord);
        gl_FragColor = vec4(texColor1[0], texColor1[1], texColor1[2], 1);
    }


}
