struct Material {
    vec3 aColor;
    vec3 dColor;
    vec3 sColor;
    float shine;
};

attribute vec3 aPosition;
attribute vec3 aNormal;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform vec3 uLColor;
uniform vec3 uLightVector;
varying vec2 vTexCoord;
attribute vec2 aTexCoord;

varying vec3 vColor;
varying vec3 vLight;
varying vec3 vReflection;
varying vec3 vView;
uniform Material uMat;

varying vec3 vNormal;

void main() {
    vNormal = vec3(normalize(uModelMatrix * vec4(aNormal, 0)));
    vec3 vPosition = vec3(uModelMatrix* vec4(aPosition.x, aPosition.y, aPosition.z, 1));
    vPosition = vec3(uViewMatrix * vec4(vPosition, 1));
    gl_Position = uProjMatrix * vec4(vPosition, 1);
    
    //vLight = normalize(uLightPos - vPosition);
    vLight = uLightVector;
    vView = normalize(-vPosition);
    vReflection = normalize(-reflect(vLight, vNormal));
    vTexCoord = aTexCoord;

}
